// Generated by CoffeeScript 1.10.0
(function() {
  module.exports = {
    calculate: function(pattern, housing) {
      var Cl, Cs, Cw, F, Gmin, Jh, Js, Jt, Lmax, Lmin, Ltol, P, Smax, SmaxRms, Smin, Stol, StolRms, Tmax, Tmin, Ttol, Wmax, Wmin, Wtol, Xmax, Zmax, heel, ref, ref1, ref2, settings, side, toe;
      settings = pattern.settings;
      toe = {
        L: 0.15,
        N: 0.35,
        M: 0.55
      };
      heel = {
        L: 0.25,
        N: 0.35,
        M: 0.45
      };
      side = pattern.pitch > 0.625 ? {
        L: 0.01,
        N: 0.03,
        M: 0.05
      } : {
        L: -0.04,
        N: -0.02,
        M: 0.01
      };
      Lmin = housing.leadSpan.min;
      Lmax = housing.leadSpan.max;
      Ltol = housing.leadSpan.tol;
      Tmin = housing.leadLength.min;
      Tmax = housing.leadLength.max;
      Ttol = housing.leadLength.tol;
      Wmin = housing.leadWidth.min;
      Wmax = housing.leadWidth.max;
      Wtol = housing.leadWidth.tol;
      F = settings.tolerance.fabrication;
      P = 2 * settings.tolerance.placement;
      Jt = (ref = pattern.toe) != null ? ref : toe[settings.densityLevel];
      Jh = (ref1 = pattern.heel) != null ? ref1 : heel[settings.densityLevel];
      Js = (ref2 = pattern.side) != null ? ref2 : side[settings.densityLevel];
      Smin = Lmin - 2 * Tmax;
      Smax = Lmax - 2 * Tmin;
      Stol = Ltol + 2 * Ttol;
      StolRms = Math.sqrt(Ltol * Ltol + 2 * Ttol * Ttol);
      SmaxRms = Smax - (Stol - StolRms) / 2;
      Cl = Ltol;
      Cs = StolRms;
      Cw = Wtol;
      Zmax = Lmin + 2 * Jt + Math.sqrt(Cl * Cl + F * F + P * P);
      Gmin = SmaxRms - 2 * Jh - Math.sqrt(Cs * Cs + F * F + P * P);
      Xmax = Wmin + 2 * Js + Math.sqrt(Cw * Cw + F * F + P * P);
      return {
        span: Zmax,
        gap: Gmin,
        height: Xmax
      };
    },
    pad: function(dimensions, pattern) {
      var padDistance, padHeight, padWidth, placeRoundoff, ref, ref1, sizeRoundoff;
      padWidth = (dimensions.span - dimensions.gap) / 2;
      padHeight = dimensions.height;
      padDistance = (dimensions.span + dimensions.gap) / 2;
      sizeRoundoff = (ref = pattern.sizeRoundoff) != null ? ref : 0.05;
      placeRoundoff = (ref1 = pattern.placeRoundoff) != null ? ref1 : 0.1;
      padWidth = Math.ceil(padWidth / sizeRoundoff) * sizeRoundoff;
      padHeight = Math.ceil(padHeight / sizeRoundoff) * sizeRoundoff;
      padDistance = Math.round(padDistance / placeRoundoff) * placeRoundoff;
      return {
        width: padWidth,
        height: padHeight,
        distance: padDistance
      };
    }
  };

}).call(this);
