// Generated by CoffeeScript 1.10.0
(function() {
  var gullwing, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  gullwing = require('./common/gullwing');

  module.exports = function(pattern, housing) {
    var bodyLength, bodyWidth, defaultShape, dims1, dims2, fontSize, i, j, k, l, leadCount1, leadCount2, leadLength1, leadLength2, lineWidth, m, n, num, o, pad1, pad2, padDims1, padDims2, padDistance1, padDistance2, padHeight1, padHeight2, padSpace1, padSpace2, padWidth1, padWidth2, pitch, r, rectHeight, rectWidth, ref, ref1, ref2, ref3, ref4, ref5, settings, shift, x, y;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["QFP%dP%dX%dX%d-%d"].concat(slice.call([housing.pitch * 100, housing.leadSpan1.nom * 100, housing.leadSpan2.nom * 100, housing.height * 100, housing.leadCount].map((function(_this) {
        return function(a) {
          return Math.round(a);
        };
      })(this)))));
    }
    settings = pattern.settings;
    pitch = housing.pitch;
    leadCount1 = housing.leadCount1;
    leadCount2 = housing.leadCount2;
    housing.leadSpan = housing.leadSpan1;
    dims1 = gullwing.calculate(pattern, housing);
    housing.leadSpan = housing.leadSpan2;
    dims2 = gullwing.calculate(pattern, housing);
    defaultShape = 'oval';
    if (dims1.gap < housing.bodyWidth.nom) {
      dims1.gap = housing.bodyWidth.nom;
      defaultShape = 'rectangle';
    }
    if (dims2.gap < housing.bodyLength.nom) {
      dims2.gap = housing.bodyLength.nom;
      defaultShape = 'rectangle';
    }
    padDims1 = gullwing.pad(dims1, pattern);
    padWidth1 = padDims1.width;
    padHeight1 = padDims1.height;
    padDistance1 = padDims1.distance;
    padDims2 = gullwing.pad(dims1, pattern);
    padWidth2 = padDims1.width;
    padHeight2 = padDims1.height;
    padDistance2 = padDims1.distance;
    pad1 = {
      type: 'smd',
      width: padWidth1,
      height: padHeight1
    };
    pad2 = {
      type: 'smd',
      width: padHeight2,
      height: padWidth2,
      shape: defaultShape
    };
    pattern.setLayer('top');
    pad1.x = -padDistance1 / 2;
    y = -pitch * (leadCount1 / 2 - 0.5);
    num = 1;
    for (i = j = 1, ref = leadCount1; 1 <= ref ? j <= ref : j >= ref; i = 1 <= ref ? ++j : --j) {
      pad1.name = num++;
      pad1.y = y;
      pad1.shape = i === 1 ? 'rectangle' : defaultShape;
      pattern.addPad(pad1);
      y += pitch;
    }
    x = -pitch * (leadCount2 / 2 - 0.5);
    pad2.y = padDistance2 / 2;
    for (i = k = 1, ref1 = leadCount2; 1 <= ref1 ? k <= ref1 : k >= ref1; i = 1 <= ref1 ? ++k : --k) {
      pad2.name = num++;
      pad2.x = x;
      pattern.addPad(pad2);
      x += pitch;
    }
    pad1.x = padDistance1 / 2;
    y -= pitch;
    for (i = l = 1, ref2 = leadCount1; 1 <= ref2 ? l <= ref2 : l >= ref2; i = 1 <= ref2 ? ++l : --l) {
      pad1.name = num++;
      pad1.y = y;
      pattern.addPad(pad1);
      y -= pitch;
    }
    x -= pitch;
    pad2.y = -padDistance2 / 2;
    for (i = m = 1, ref3 = leadCount2; 1 <= ref3 ? m <= ref3 : m >= ref3; i = 1 <= ref3 ? ++m : --m) {
      pad2.name = num++;
      pad2.x = x;
      pattern.addPad(pad2);
      x -= pitch;
    }
    pattern.setLayer('topSilkscreen');
    lineWidth = settings.lineWidth.silkscreen;
    pattern.setLineWidth(lineWidth);
    rectWidth = housing.bodyWidth.nom;
    padSpace1 = padDistance1 - padWidth1 - 2 * settings.clearance.padToSilk - lineWidth;
    if (rectWidth >= padSpace1) {
      rectWidth = padSpace1;
    }
    rectHeight = housing.bodyLength.nom;
    padSpace2 = padDistance2 - padWidth2 - 2 * settings.clearance.padToSilk - lineWidth;
    if (rectHeight >= padSpace2) {
      rectHeight = padSpace2;
    }
    pattern.addRectangle({
      x: -rectWidth / 2,
      y: -rectHeight / 2,
      width: rectWidth,
      height: rectHeight
    });
    r = 0.25;
    x = (-padDistance1 - padWidth1) / 2 + r;
    y = -pitch * (leadCount1 / 2 - 0.5) - padHeight1 / 2 - r - settings.clearance.padToSilk;
    pattern.addCircle({
      x: x,
      y: y,
      radius: r / 2,
      lineWidth: r
    });
    r = 0.5;
    shift = rectWidth / 2 - r;
    if (shift > 0.5) {
      shift = 0.5;
    }
    x = -rectWidth / 2 + r + shift;
    y = -rectHeight / 2 + r + shift;
    pattern.addCircle({
      x: x,
      y: y,
      radius: r / 2,
      lineWidth: r
    });
    fontSize = settings.fontSize.refDes;
    pattern.addAttribute('refDes', {
      x: 0,
      y: -padDistance2 / 2 - padWidth2 / 2 - fontSize / 2 - 2 * lineWidth,
      halign: 'center',
      valign: 'center'
    });
    pattern.setLayer('topAssembly');
    pattern.setLineWidth(settings.lineWidth.assembly);
    bodyWidth = housing.bodyWidth.nom;
    bodyLength = housing.bodyLength.nom;
    leadLength1 = (housing.leadSpan1.nom - housing.bodyWidth.nom) / 2;
    leadLength2 = (housing.leadSpan2.nom - housing.bodyLength.nom) / 2;
    pattern.addRectangle({
      x: -bodyWidth / 2,
      y: -bodyLength / 2,
      width: bodyWidth,
      height: bodyLength
    });
    y = -pitch * (leadCount1 / 2 - 0.5);
    for (i = n = 1, ref4 = leadCount1; 1 <= ref4 ? n <= ref4 : n >= ref4; i = 1 <= ref4 ? ++n : --n) {
      pattern.addLine({
        x1: -bodyWidth / 2,
        y1: y,
        x2: -bodyWidth / 2 - leadLength1,
        y2: y
      });
      pattern.addLine({
        x1: bodyWidth / 2,
        y1: y,
        x2: bodyWidth / 2 + leadLength1,
        y2: y
      });
      y += pitch;
    }
    x = -pitch * (leadCount2 / 2 - 0.5);
    for (i = o = 1, ref5 = leadCount2; 1 <= ref5 ? o <= ref5 : o >= ref5; i = 1 <= ref5 ? ++o : --o) {
      pattern.addLine({
        x1: x,
        y1: -bodyLength / 2,
        x2: x,
        y2: -bodyLength / 2 - leadLength2
      });
      pattern.addLine({
        x1: x,
        y1: bodyLength / 2,
        x2: x,
        y2: bodyLength / 2 + leadLength2
      });
      x += pitch;
    }
    r = 0.5;
    shift = bodyWidth / 2 - r;
    if (shift > 0.5) {
      shift = 0.5;
    }
    x = -bodyWidth / 2 + r + shift;
    y = -bodyLength / 2 + r + shift;
    pattern.addCircle({
      x: x,
      y: y,
      radius: r
    });
    fontSize = settings.fontSize.value;
    return pattern.addAttribute('value', {
      text: pattern.name,
      x: 0,
      y: bodyLength / 2 + leadLength2 + fontSize / 2 + 0.5,
      halign: 'center',
      valign: 'center'
    });
  };

}).call(this);
