// Generated by CoffeeScript 1.10.0
(function() {
  var gullwing, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  gullwing = require('./common/gullwing');

  module.exports = function(pattern, housing) {
    var bodyLength, bodyWidth, defaultShape, dims, fontSize, i, j, k, l, leadCount, leadLength, lineWidth, num, pad, padDims, padDistance, padHeight, padSpace, padWidth, pitch, r, rectWidth, ref, ref1, ref2, ref3, settings, shift, x, y;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["SOP%dP%dX%d-%d"].concat(slice.call([housing.pitch * 100, housing.leadSpan.nom * 100, housing.height * 100, housing.leadCount].map((function(_this) {
        return function(a) {
          return Math.round(a);
        };
      })(this)))));
    }
    settings = pattern.settings;
    pitch = housing.pitch;
    leadCount = housing.leadCount;
    dims = gullwing.calculate(pattern, housing);
    defaultShape = 'oval';
    if (dims.gap < housing.bodyWidth.nom) {
      dims.gap = housing.bodyWidth.nom;
      defaultShape = 'rectangle';
    }
    padDims = gullwing.pad(dims, pattern);
    padWidth = padDims.width;
    padHeight = padDims.height;
    padDistance = padDims.distance;
    pad = {
      type: 'smd',
      width: padWidth,
      height: padHeight
    };
    pattern.setLayer('top');
    pad.x = -padDistance / 2;
    y = -pitch * (leadCount / 4 - 0.5);
    num = 1;
    for (i = j = 1, ref = leadCount / 2; 1 <= ref ? j <= ref : j >= ref; i = 1 <= ref ? ++j : --j) {
      pad.name = num++;
      pad.y = y;
      pad.shape = i === 1 ? 'rectangle' : defaultShape;
      pattern.addPad(pad);
      y += pitch;
    }
    pad.x = padDistance / 2;
    y -= pitch;
    for (i = k = ref1 = leadCount / 2 + 1, ref2 = leadCount; ref1 <= ref2 ? k <= ref2 : k >= ref2; i = ref1 <= ref2 ? ++k : --k) {
      pad.name = num++;
      pad.y = y;
      pattern.addPad(pad);
      y -= pitch;
    }
    pattern.setLayer('topSilkscreen');
    lineWidth = settings.lineWidth.silkscreen;
    pattern.setLineWidth(lineWidth);
    rectWidth = housing.bodyWidth.nom;
    padSpace = padDistance - padWidth - 2 * settings.clearance.padToSilk - lineWidth;
    if (rectWidth >= padSpace) {
      rectWidth = padSpace;
    }
    bodyLength = housing.bodyLength.nom;
    pattern.addRectangle({
      x: -rectWidth / 2,
      y: -bodyLength / 2,
      width: rectWidth,
      height: bodyLength
    });
    r = 0.25;
    x = (-padDistance - padWidth) / 2 + r;
    y = -pitch * (leadCount / 4 - 0.5) - padHeight / 2 - r - settings.clearance.padToSilk;
    pattern.addCircle({
      x: x,
      y: y,
      radius: r / 2,
      lineWidth: r
    });
    r = 0.5;
    shift = rectWidth / 2 - r;
    if (shift > 0.5) {
      shift = 0.5;
    }
    x = -rectWidth / 2 + r + shift;
    y = -bodyLength / 2 + r + shift;
    pattern.addCircle({
      x: x,
      y: y,
      radius: r / 2,
      lineWidth: r
    });
    fontSize = settings.fontSize.refDes;
    pattern.addAttribute('refDes', {
      x: 0,
      y: -bodyLength / 2 - fontSize / 2 - 2 * lineWidth,
      halign: 'center',
      valign: 'center'
    });
    pattern.setLayer('topAssembly');
    pattern.setLineWidth(settings.lineWidth.assembly);
    bodyWidth = housing.bodyWidth.nom;
    leadLength = (housing.leadSpan.nom - housing.bodyWidth.nom) / 2;
    pattern.addRectangle({
      x: -bodyWidth / 2,
      y: -bodyLength / 2,
      width: bodyWidth,
      height: bodyLength
    });
    y = -pitch * (leadCount / 4 - 0.5);
    for (i = l = 1, ref3 = leadCount / 2; 1 <= ref3 ? l <= ref3 : l >= ref3; i = 1 <= ref3 ? ++l : --l) {
      pattern.addLine({
        x1: -bodyWidth / 2,
        y1: y,
        x2: -bodyWidth / 2 - leadLength,
        y2: y
      });
      pattern.addLine({
        x1: bodyWidth / 2,
        y1: y,
        x2: bodyWidth / 2 + leadLength,
        y2: y
      });
      y += pitch;
    }
    r = 0.5;
    shift = bodyWidth / 2 - r;
    if (shift > 0.5) {
      shift = 0.5;
    }
    x = -bodyWidth / 2 + r + shift;
    y = -bodyLength / 2 + r + shift;
    pattern.addCircle({
      x: x,
      y: y,
      radius: r
    });
    fontSize = settings.fontSize.value;
    return pattern.addAttribute('value', {
      text: pattern.name,
      x: 0,
      y: bodyLength / 2 + fontSize / 2 + 0.5,
      halign: 'center',
      valign: 'center'
    });
  };

}).call(this);
