// Generated by CoffeeScript 1.10.0
(function() {
  var QedaElement, QedaPattern, QedaSymbol, fs, yaml;

  fs = require('fs');

  yaml = require('js-yaml');

  QedaSymbol = require('./qeda-symbol');

  QedaPattern = require('./qeda-pattern');

  QedaElement = (function() {
    function QedaElement(library, definition) {
      var alias, group, groups, i, j, key, l, last, len, len1, len2, len3, m, name, number, o, p, part, pins, q, r, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, suffix, suffixes, value;
      this.library = library;
      this.mergeObjects(this, definition);
      if (this.alias != null) {
        if (this.aliases == null) {
          this.aliases = [];
        }
        this.aliases.concat(this.alias.replace(/\s+/g, '').split(','));
      }
      if (this.suffix != null) {
        if (this.aliases == null) {
          this.aliases = [];
        }
        suffixes = this.suffix.replace(/\s+/g, '').split(',');
        for (l = 0, len = suffixes.length; l < len; l++) {
          suffix = suffixes[l];
          alias = this.name + suffix;
          if (this.aliases.indexOf(alias) === -1) {
            this.aliases.push(alias);
          }
        }
      }
      this.longestAlias = this.name;
      if (this.alias != null) {
        ref = this.alias;
        for (m = 0, len1 = ref.length; m < len1; m++) {
          alias = ref[m];
          if (alias.length > this.longestAlias.length) {
            this.longestAlias = alias;
          }
        }
      }
      this.refDes = 'REF';
      this.symbols = [];
      this.pattern = new QedaPattern(this);
      this.pins = [];
      this.pinGroups = [];
      this._letters = ['', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'R', 'T', 'U', 'V', 'W', 'Y'];
      last = this._letters.length - 1;
      for (i = o = 1, ref1 = last; 1 <= ref1 ? o <= ref1 : o >= ref1; i = 1 <= ref1 ? ++o : --o) {
        for (j = p = ref2 = i, ref3 = last; ref2 <= ref3 ? p <= ref3 : p >= ref3; j = ref2 <= ref3 ? ++p : --p) {
          this._letters.push(this._letters[i] + this._letters[j]);
        }
      }
      this.delimiter = {};
      ref4 = this.joint;
      for (key in ref4) {
        value = ref4[key];
        groups = this.parseGroups(key);
        for (q = 0, len2 = groups.length; q < len2; q++) {
          group = groups[q];
          this.delimiter[group] = value;
        }
      }
      ref5 = this.pinout;
      for (name in ref5) {
        value = ref5[name];
        pins = this._addPins(name, value);
        this.pinGroups[name] = pins;
        if (typeof value === 'object') {
          continue;
        }
        for (r = 0, len3 = pins.length; r < len3; r++) {
          number = pins[r];
          if (this.pins[number] == null) {
            this.pins[number] = this._pinObj(number, name);
          } else {
            this.pins[number].name += '/' + name;
          }
        }
      }
      ref6 = this.groups;
      for (key in ref6) {
        value = ref6[key];
        this.pinGroups[key] = this._concatenateGroups(value);
      }
      if (this.parts != null) {
        ref7 = this.parts;
        for (name in ref7) {
          part = ref7[name];
          this.symbols.push(new QedaSymbol(this, this.parseGroups(part), name));
        }
      } else {
        part = [];
        if (this.groups != null) {
          for (key in this.groups) {
            part.push(key);
          }
        } else {
          for (key in this.pinout) {
            part.push(key);
          }
        }
        this.symbols.push(new QedaSymbol(this, part));
      }
    }

    QedaElement.prototype.isFloat = function(n) {
      return Number(n) && (n % 1 !== 0);
    };

    QedaElement.prototype.mergeObjects = function(dest, src) {
      var k, results, v;
      results = [];
      for (k in src) {
        v = src[k];
        if (typeof v === 'object' && (!Array.isArray(v)) && dest.hasOwnProperty(k)) {
          results.push(this.mergeObjects(dest[k], v));
        } else {
          results.push(dest[k] = v);
        }
      }
      return results;
    };

    QedaElement.prototype.parseGroups = function(groups) {
      var cap, group, i, l, len, m, ref, ref1, result;
      result = [];
      groups = groups.replace(/\s+/g, '').split(',');
      for (l = 0, len = groups.length; l < len; l++) {
        group = groups[l];
        cap = /(\w+)(\d+)-(\d+)/.exec(group);
        if (cap) {
          for (i = m = ref = cap[2], ref1 = cap[3]; ref <= ref1 ? m <= ref1 : m >= ref1; i = ref <= ref1 ? ++m : --m) {
            result.push(cap[1] + i);
          }
        } else {
          result.push(group);
        }
      }
      return result;
    };

    QedaElement.prototype.render = function() {
      var base, cap, dirName, error, error1, fileName, handler, key, l, len, outline, ref, ref1, ref2, symbol, value;
      if (this._rendered == null) {
        this._rendered = false;
      }
      if (this._rendered) {
        return;
      }
      handler = require("./element/" + this.library.elementStyle);
      handler(this);
      ref = this.symbols;
      for (l = 0, len = ref.length; l < len; l++) {
        symbol = ref[l];
        if (((ref1 = this.schematic) != null ? ref1.symbol : void 0) != null) {
          handler = require("./symbol/" + this.library.symbolStyle + "/" + (this.schematic.symbol.toLowerCase()));
          handler(symbol);
        }
      }
      if (((ref2 = this.housing) != null ? ref2.outline : void 0) != null) {
        cap = this.housing.outline.split(' ');
        dirName = cap.shift().toLowerCase();
        fileName = cap.shift().toLowerCase();
        try {
          outline = yaml.safeLoad(fs.readFileSync(__dirname + ("/outline/" + dirName + "/" + fileName + ".yaml")));
        } catch (error1) {
          error = error1;
          console.error("Loading outline '" + this.housing.outline + "': Error: " + error.message);
          process.exit(1);
        }
        while (true) {
          for (key in outline) {
            value = outline[key];
            if ((typeof value === 'number') || (typeof value === 'string')) {
              this.housing[key] = value;
            }
          }
          if (cap.length === 0) {
            break;
          }
          outline = outline[cap.shift()];
          if (outline == null) {
            break;
          }
        }
      }
      this._convertDimensions(this.housing);
      handler = require("./pattern/" + this.library.patternStyle + "/" + this.pattern.handler);
      handler(this.pattern, this.housing);
      if ((base = this.pattern).name == null) {
        base.name = this.housing.pattern;
      }
      return this._rendered = true;
    };

    QedaElement.prototype._addPins = function(key, value) {
      var cap, col, col1, col2, l, len, len1, m, name, number, numbers, o, p, pins, ref, ref1, ref2, ref3, result, row, row1, row2;
      result = [];
      if (typeof value === 'object') {
        for (name in value) {
          numbers = value[name];
          pins = this._addPins(name, numbers);
          if (this.delimiter[key]) {
            name = key + this.delimiter[key] + name;
          }
          for (l = 0, len = pins.length; l < len; l++) {
            number = pins[l];
            if (this.pins[number] == null) {
              this.pins[number] = this._pinObj(number, name);
            } else {
              this.pins[number].name += '/' + name;
            }
          }
          result = result.concat(pins);
        }
      } else {
        if (typeof value === 'number') {
          value = value.toString();
        }
        numbers = value.replace(/\s+/g, '').split(',');
        for (m = 0, len1 = numbers.length; m < len1; m++) {
          number = numbers[m];
          cap = /([A-Z]*)(\d+)-([A-Z]*)(\d+)/.exec(number);
          if (!cap) {
            result.push(number);
          } else {
            row1 = this._letters.indexOf(cap[1]);
            row2 = this._letters.indexOf(cap[3]);
            col1 = parseInt(cap[2]);
            col2 = parseInt(cap[4]);
            for (row = o = ref = row1, ref1 = row2; ref <= ref1 ? o <= ref1 : o >= ref1; row = ref <= ref1 ? ++o : --o) {
              for (col = p = ref2 = col1, ref3 = col2; ref2 <= ref3 ? p <= ref3 : p >= ref3; col = ref2 <= ref3 ? ++p : --p) {
                result.push(this._letters[row] + col);
              }
            }
          }
        }
      }
      return result;
    };

    QedaElement.prototype._concatenateGroups = function(groups) {
      var group, l, len, pinGroup, result;
      result = [];
      groups = this.parseGroups(groups);
      for (l = 0, len = groups.length; l < len; l++) {
        group = groups[l];
        pinGroup = this.pinGroups[group];
        if (pinGroup != null) {
          result = result.concat(pinGroup);
        }
      }
      return result;
    };

    QedaElement.prototype._convertDimensions = function(housing) {
      var key, max, min, nom, results, tol, value;
      results = [];
      for (key in housing) {
        value = housing[key];
        if (typeof value === 'string') {
          value = value.replace(/\s+/g, '').split('-').map(function(a) {
            return parseFloat(a);
          });
        }
        if (Array.isArray(value) && value.length > 0) {
          min = value[0];
          max = value.length > 1 ? value[1] : min;
          nom = (max + min) / 2;
          tol = max - min;
          results.push(housing[key] = {
            min: min,
            max: max,
            nom: nom,
            tol: tol
          });
        } else {
          results.push(void 0);
        }
      }
      return results;
    };

    QedaElement.prototype._pinObj = function(number, name) {
      var l, len, obj, pins, prop, props;
      obj = {
        name: name,
        number: number
      };
      if (this.properties != null) {
        props = ['bidir', 'ground', 'in', 'inverted', 'nc', 'out', 'passive', 'power', 'z'];
        for (l = 0, len = props.length; l < len; l++) {
          prop = props[l];
          if (this.properties[prop] != null) {
            pins = this.parseGroups(this.properties[prop]);
            obj[prop] = pins.indexOf(name) !== -1;
          }
        }
      }
      return obj;
    };

    return QedaElement;

  })();

  module.exports = QedaElement;

}).call(this);
