// Generated by CoffeeScript 1.10.0
(function() {
  var QedaPattern,
    hasProp = {}.hasOwnProperty;

  QedaPattern = (function() {
    function QedaPattern(element) {
      this.element = element;
      this.handler = this.element.housing.pattern.toLowerCase();
      this.settings = this.element.library.pattern;
      this.shapes = [];
      this.layer = 'top';
      this.lineWidth = 0;
      this.type = 'smd';
      this.attributes = {};
    }

    QedaPattern.prototype.addAttribute = function(name, attribute) {
      attribute.name = name;
      return this.attributes[name] = this.addShape('attribute', attribute);
    };

    QedaPattern.prototype.addCircle = function(circle) {
      return this.addShape('circle', circle);
    };

    QedaPattern.prototype.addLine = function(line) {
      return this.addShape('line', line);
    };

    QedaPattern.prototype.addPad = function(pad) {
      if (pad.type !== 'smd') {
        this.type = 'through-hole';
      }
      return this.addShape('pad', pad);
    };

    QedaPattern.prototype.addRectangle = function(rectangle) {
      var x1, x2, y1, y2;
      x1 = rectangle.x;
      y1 = rectangle.y;
      x2 = rectangle.x + rectangle.width;
      y2 = rectangle.y + rectangle.height;
      this.addLine({
        x1: x1,
        y1: y1,
        x2: x2,
        y2: y1
      });
      this.addLine({
        x1: x2,
        y1: y1,
        x2: x2,
        y2: y2
      });
      this.addLine({
        x1: x1,
        y1: y2,
        x2: x2,
        y2: y2
      });
      return this.addLine({
        x1: x1,
        y1: y1,
        x2: x1,
        y2: y2
      });
    };

    QedaPattern.prototype.addShape = function(kind, shape) {
      var obj, prop;
      obj = {
        kind: kind
      };
      for (prop in shape) {
        if (!hasProp.call(shape, prop)) continue;
        obj[prop] = shape[prop];
      }
      if (obj.layer == null) {
        obj.layer = this.layer;
      }
      if (obj.lineWidth == null) {
        obj.lineWidth = this.lineWidth;
      }
      this.shapes.push(obj);
      return obj;
    };

    QedaPattern.prototype.addText = function(text) {
      return this.addShape('text', text);
    };

    QedaPattern.prototype.mergeObjects = function(dest, src) {
      var k, results, v;
      results = [];
      for (k in src) {
        v = src[k];
        if (typeof v === 'object' && dest.hasOwnProperty(k)) {
          results.push(this.mergeObjects(dest[k], v));
        } else {
          results.push(dest[k] = v);
        }
      }
      return results;
    };

    QedaPattern.prototype.setLayer = function(layer) {
      return this.layer = layer;
    };

    QedaPattern.prototype.setLineWidth = function(lineWidth) {
      return this.lineWidth = lineWidth;
    };

    return QedaPattern;

  })();

  module.exports = QedaPattern;

}).call(this);
