// Generated by CoffeeScript 1.10.0
(function() {
  var QedaSymbol,
    hasProp = {}.hasOwnProperty;

  QedaSymbol = (function() {
    function QedaSymbol(element, groups1, name1) {
      var both, delta, group, groups, i, j, len, len1, pinGroup, side, sides, toLeft, toRight;
      this.element = element;
      this.groups = groups1;
      this.name = name1;
      this.settings = this.element.library.symbol;
      this.schematic = this.element.schematic;
      this.shapes = [];
      this.attributes = [];
      sides = ['left', 'right', 'top', 'bottom'];
      for (i = 0, len = sides.length; i < len; i++) {
        side = sides[i];
        this[side] = [];
        if (this.schematic[side] != null) {
          groups = this.element.parseGroups(this.schematic[side]);
          for (j = 0, len1 = groups.length; j < len1; j++) {
            group = groups[j];
            pinGroup = this.element.pinGroups[group];
            if ((this.groups.indexOf(group) !== -1) && (pinGroup != null)) {
              if (this[side].length > 0) {
                this[side].push('-');
              }
              this[side] = this[side].concat(pinGroup);
            }
          }
        }
      }
      both = this.left.filter((function(_this) {
        return function(a) {
          return (a !== '-') && (_this.right.indexOf(a) !== -1);
        };
      })(this));
      delta = Math.ceil((this.right.length - this.left.length + both.length) / 2);
      toLeft = both.slice(0, +(delta - 1) + 1 || 9e9);
      toRight = both.slice(delta);
      this.left = this.left.filter((function(_this) {
        return function(a) {
          return toRight.indexOf(a) === -1;
        };
      })(this));
      this.right = this.right.filter((function(_this) {
        return function(a) {
          return toLeft.indexOf(a) === -1;
        };
      })(this));
    }

    QedaSymbol.prototype.addAttribute = function(name, attribute) {
      attribute.name = name;
      return this.attributes[name] = this.addShape('attribute', attribute);
    };

    QedaSymbol.prototype.addPin = function(pin) {
      return this.addShape('pin', pin);
    };

    QedaSymbol.prototype.addRectangle = function(rectangle) {
      return this.addShape('rectangle', rectangle);
    };

    QedaSymbol.prototype.addShape = function(kind, shape) {
      var obj, prop;
      obj = {
        kind: kind
      };
      for (prop in shape) {
        if (!hasProp.call(shape, prop)) continue;
        obj[prop] = shape[prop];
      }
      this.shapes.push(obj);
      return obj;
    };

    QedaSymbol.prototype.invertVertical = function() {
      var i, len, ref, results, shape;
      ref = this.shapes;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        shape = ref[i];
        if (shape.y != null) {
          shape.y *= -1;
        }
        if (shape.height != null) {
          results.push(shape.height *= -1);
        } else {
          results.push(void 0);
        }
      }
      return results;
    };

    QedaSymbol.prototype.resize = function(gridSize) {
      var i, len, ref, results, shape;
      ref = this.shapes;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        shape = ref[i];
        if (shape.x != null) {
          shape.x *= gridSize;
        }
        if (shape.y != null) {
          shape.y *= gridSize;
        }
        if (shape.length != null) {
          shape.length *= gridSize;
        }
        if (shape.width != null) {
          shape.width *= gridSize;
        }
        if (shape.height != null) {
          results.push(shape.height *= gridSize);
        } else {
          results.push(void 0);
        }
      }
      return results;
    };

    return QedaSymbol;

  })();

  module.exports = QedaSymbol;

}).call(this);
